import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  * Caesar-Verschlsselung
  *
  * @version 1.1 vom 02.06.2012
  * @author Roland Mechling
  */

public class Caesar extends JFrame {
  // Anfang Attribute
  private JTextField jTextField1 = new JTextField();
  private JTextField jTextField2 = new JTextField();
  private JTextField jTextField3 = new JTextField();
  private JLabel jLabel1 = new JLabel();
  
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JNumberField jNumberField1 = new JNumberField();
  private JLabel jLabel4 = new JLabel();
  // Ende Attribute
  
  public Caesar(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 292; 
    int frameHeight = 357;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);

    // Anfang Komponenten
    jTextField1.setBounds(8, 32, 273, 33);
    cp.add(jTextField1);
    jTextField2.setBounds(8, 176, 273, 33);
    cp.add(jTextField2);
    jTextField3.setBounds(8, 288, 273, 33);
    cp.add(jTextField3);
    jLabel1.setBounds(8, 8, 58, 19);
    jLabel1.setText("Klartext : ");
    cp.add(jLabel1);
    jButton1.setBounds(72, 128, 145, 41);
    jButton1.setText("Verschlsseln");
    jButton1.setMargin(new Insets(2, 2, 2, 2));
    jButton1.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jButton2.setBounds(72, 240, 145, 41);
    jButton2.setText("Entschlsseln");
    jButton2.setMargin(new Insets(2, 2, 2, 2));
    jButton2.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton2_ActionPerformed(evt);
      }
    });
    cp.add(jButton2);
    jNumberField1.setBounds(120, 72, 65, 25);
    jNumberField1.setText("3");
    cp.add(jNumberField1);
    jLabel4.setBounds(8, 72, 92, 19);
    jLabel4.setText("Verschiebung : ");
    cp.add(jLabel4);
    // Ende Komponenten
    
    setVisible(true);
  }
  
  // Anfang Methoden
  
  /*
   *  berprft. ob das bergebene Zeichen z
   *  ein Grobuchstabe ist; nur in diesem Falle
   *  wird <em>true</em> zurckgegeben
   */
  private boolean isValid(char z) {
    return (z >= 'A') && (z <= 'Z');
  }
  
  /*
   * Implementiert die "Caesar-Verschiebung" des Alphabets:
   * es wird derjenige Buchstabe c berechnet und zurckgegeben,
   * der im Alphabet v Stellen hinter dem bergebenen Original-
   * Buchstaben z steht.
   */
  private char caesar(char z, int v) {
    int a = (int) z;        // Typ-Umandlung char z ==> int a
    int n = a - (int) 'A';  // ASCII-Nr.-Bereich verschieben nach [0..25]
    int m = (n + v) % 26;   // Eigentliche Verschlsselung
    int b = m + (int) 'A';  // zurckverschieben in originalen ASCII-Nr.-Bereich
    char c = (char) b;      // Typ-Umwandlung int b ==> char c
    return c;               // gib c zurck
  }
  
  /*
   *  Verschlsselt den bergebenen Text mit dem Caesar-Verfahren;
   *  benutzt dazu die bergebene Verschiebung und gibt den
   *  verschlsselten Text zurck.
   */
  private String encrypt(String text, int verschiebung) {
    text = text.toUpperCase();   // Alles in Grobuchstaben umschreiben
    String encrypted = "";       // verschlsselter Text, zunchst leer
    int max = text.length() - 1; // Index des letzten Klartext-Zeichens
    int i = 0;                   // Zhlvariable i, mit 0 initialisiert
    while (i <= max) {           // solange i auf einen Text-Buchstaben zeigt
      char b = text.charAt(i);       // nimm diesen Buchstaben b an der Stelle i
      if (isValid(b)) {              // wenn b ein gltiger Buchstabe ist:
        char v = caesar(b, verschiebung); // verschlsseln und an den...
        encrypted = encrypted + v;        // ...verschlsselten Text anfgen
      };
      i++;                       // c um eins erhoehen
    }
    return encrypted;            // Verschlsselten Text zurckliefern
  }
  
  /*
   *  Entschlsselt den bergebenen Geheimtext, der mit der bergebenen
   *  Verschiebung Caesar-verschlsselt wurde, und gibt den
   *  entschlsselten Text zurck. Wie funktioniert das ???
   */
  private String decrypt(String text, int verschiebung) {
    String decrStr = encrypt(text, 26 - verschiebung);
    return decrStr;
  }
  
  public void jButton1_ActionPerformed(ActionEvent evt) {
    String encrStr = encrypt(jTextField1.getText(), jNumberField1.getInt());
    jTextField2.setText(encrStr);
  }
  
  public void jButton2_ActionPerformed(ActionEvent evt) {
    String decrStr = decrypt(jTextField2.getText(), jNumberField1.getInt());
    jTextField3.setText(decrStr);
  }
  
  public static void main(String[] args) {
    new Caesar("Caesar-Verschlsselung");
  }

  // Ende Methoden
}
